{*****************************************************************************}
{    F.A.Q Delphi - www.developpez.com                                        }
{                                                                             }
{ Comment passer au premier plan une application instancie une seconde fois? }
{ Auteur : hachesse@developpez.com                                            }
{                                                                             }
{ Developper avec Delphi 6                                                    }
{*****************************************************************************}

{*****************************************************************************}
{    Note importante                                                          }
{                                                                             }
{ Avant de tester ce programme, il est fortement recommander de faire une     }
{ sauvegarde de votre base de registre. L'auteur ne pourra en aucun cas tre  }
{ tenu pour responsable des dommages qui pourront tre causs.                }
{*****************************************************************************}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Registry;

type
  TForm1 = class(TForm)
    Ecrire: TButton;
    Lire: TButton;
    EffacerCle: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ComboBox1: TComboBox;
    Label4: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    EffacerValeur: TButton;
    procedure EcrireClick(Sender: TObject);
    procedure LireClick(Sender: TObject);
    procedure EffacerCleClick(Sender: TObject);
    procedure EffacerValeurClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.EcrireClick(Sender: TObject);
var
  Registre: TRegistry;// TRegistry est une enveloppe de bas niveau
                      // pour le registre systme  et les fonctions qui manipulent ce registre.
begin
  Registre := TRegistry.Create; // On cre d'un objet pour l'interface avec la base de registre.
  try
  case ComboBox1.ItemIndex of
    0 : Registre.RootKey := HKEY_CLASSES_ROOT;     //
    1 : Registre.RootKey := HKEY_USERS;            // On spcifie la cl racine dans le registre
    2 : Registre.RootKey := HKEY_LOCAL_MACHINE;    //
  end;
    Registre.OpenKey(Edit1.Text, True);            // On ouvre la cl dans la base de registre
    Registre.WriteString(Edit2.Text, Edit3.Text);  // On crit la valeur dans la cl courante
                                                   // Ici on crit une chaine, pour les autres types utilisez
                                                   // WriteBinaryData, WriteBool,	WriteCurrency, WriteDate,	WriteDateTime,
                                                   // WriteExpandString, WriteFloat, WriteInteger, WriteString ou	WriteTime.
    Registre.CloseKey;                             // On ferme la cl du registre
    Registre.Free;                                 // On detruit l'objet et libre la mmoire
  except
    ShowMessage('Erreur dans pendant l''criture');
    Registre.Free; // On detruit l'objet et libre la mmoire
  end;
end;

procedure TForm1.LireClick(Sender: TObject);
var
  Registre: TRegistry;// TRegistry est une enveloppe de bas niveau
                      // pour le registre systme  et les fonctions qui manipulent ce registre.
begin
  Registre := TRegistry.Create; // On cre d'un objet pour l'interface avec la base de registre.
  try
  case ComboBox1.ItemIndex of
    0 : Registre.RootKey := HKEY_CLASSES_ROOT;     //
    1 : Registre.RootKey := HKEY_USERS;            // On spcifie la cl racine dans le registre
    2 : Registre.RootKey := HKEY_LOCAL_MACHINE;    //
  end;
    Registre.OpenKey(Edit1.Text, True); // On ouvre la cl dans la base de registre
    Edit3.Text:= Registre.ReadString(Edit2.Text); // On lit la valeur dans la cl courante
                                                  // Ici on lit une chaine, pour les autres types utilisez
                                                  // ReadBinaryData,	ReadBool, ReadCurrency, ReadDate,	ReadDateTime,
                                                  // ReadFloat, ReadInteger,	ReadString ou	ReadTime.
    Registre.CloseKey; // On ferme la cl du registre
    Registre.Free; // On detruit l'objet et libre la mmoire
  except
    ShowMessage('Erreur dans pendant la lecture');
    Registre.Free; // On detruit l'objet et libre la mmoire
  end;
end;

procedure TForm1.EffacerCleClick(Sender: TObject);
var
  Registre: TRegistry;// TRegistry est une enveloppe de bas niveau
                      // pour le registre systme  et les fonctions qui manipulent ce registre.
begin
  Registre := TRegistry.Create; // On cre d'un objet pour l'interface avec la base de registre.
  try
  case ComboBox1.ItemIndex of
    0 : Registre.RootKey := HKEY_CLASSES_ROOT;     //
    1 : Registre.RootKey := HKEY_USERS;            // On spcifie la cl racine dans le registre
    2 : Registre.RootKey := HKEY_LOCAL_MACHINE;    //
  end;
    Registre.OpenKey(Edit1.Text, True); // On ouvre la cl dans la base de registre
    Registre.DeleteKey(Edit1.Text); // On efface la cl du registre
    Registre.Free; // On detruit l'objet et libre la mmoire
  except
    ShowMessage('Erreur dans pendant l''effacement de la cl');
    Registre.Free; // On detruit l'objet et libre la mmoire
  end;
end;

procedure TForm1.EffacerValeurClick(Sender: TObject);
var
  Registre: TRegistry;// TRegistry est une enveloppe de bas niveau
                      // pour le registre systme  et les fonctions qui manipulent ce registre.
begin
  Registre := TRegistry.Create; // On cre d'un objet pour l'interface avec la base de registre.
  try
  case ComboBox1.ItemIndex of
    0 : Registre.RootKey := HKEY_CLASSES_ROOT;     //
    1 : Registre.RootKey := HKEY_USERS;            // On spcifie la cl racine dans le registre
    2 : Registre.RootKey := HKEY_LOCAL_MACHINE;    //
  end;
    Registre.OpenKey(Edit1.Text, True); // On ouvre la cl dans la base de registre
    Registre.DeleteValue(Edit2.Text); // On efface la valeur dans la cl
    Registre.CloseKey; // On ferme la cl du registre 
    Registre.Free; // On detruit l'objet et libre la mmoire
  except
    ShowMessage('Erreur dans pendant l''effacement de la cl');
    Registre.Free; // On detruit l'objet et libre la mmoire
  end;
end;

end.
